-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.UI.AutoListBox";
import "Tonic.UI.MenuUtils";

buttonWidth = 85;
selectionWidth = 160;
selectionHeight = 20;
startFromTop = 39;
insideBoxXOffset = selectionWidth + 5;
insideBoxYOffset = startFromTop + 200;

InventoryMenu = class( Tonic.UI.AutoListBox );

function InventoryMenu:Constructor()
	Tonic.UI.AutoListBox.Constructor( self );
	
	self.utils = Tonic.UI.MenuUtils();
	
	self.upperBar = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
	self.utils:AddLabelBox( self.upperBar, LOCALESTRINGS.InventoryMenu[1], selectionWidth + 250, selectionHeight + 10 );
	
	local addButton = Turbine.UI.Lotro.Button();
	addButton:SetText( LOCALESTRINGS.InventoryMenu[2] );
	addButton:SetSize( buttonWidth, selectionHeight );
	addButton.MouseClick = function( sender, args )
		local barid = maitre_d:Add( WINDOWBAR );
		self:RefreshComboBox( barid );
	end
	self.upperBar:AddItem( addButton );
	
	self.utils:AddLabelBox( self, LOCALESTRINGS.InventoryMenu[3], selectionWidth + 100, selectionHeight );
	
	self.barList = Tonic.UI.ComboBox();
	self.barList:SetSize( 200, 20 );
	self.barList:SetParent( self );
    self.barList.SelectedIndexChanged = function(sender, args)
		local settings = theSettingsManager:GetSettings();
		settings.selectedBar = tonumber(args.selection);
		self.scrollBox:SetVisible( true );
		menu:SetupMainMenuDisplay( INVENTORY_MODE );
		maitre_d:RefreshBars();
	end
	self.upperBar:AddItem( self.barList );
	
	self:AddSettings();
	self:AddItem( self.upperBar );
	
	self.scrollBox = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Horizontal, 0, 0, 0, 0 );

	self.sidebar = Turbine.UI.Lotro.ScrollBar();
	self.sidebar:SetParent( self.scrollBox );
	self.sidebar:SetOrientation( Turbine.UI.Orientation.Vertical );
	
	self.scrollBox:AddItem( self.settingsBox );
	self.scrollBox:AddItem( self.sidebar );
	self.settingsBox:SetVerticalScrollBar( self.sidebar );
	self:AddItem( self.scrollBox );
	self.scrollBox:SetVisible( false );
		
	self.sidebar:SetSize ( 8, windowHeight - self.upperBar:GetHeight() - 105 );
	self.settingsBox:SetSize( self.settingsBox:GetWidth(), windowHeight - self.upperBar:GetHeight() - 105 );
end

function InventoryMenu:AddSettings()
	self.settingsBox = self.utils:AddAutoListBox( self.scrollBox, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
end

function InventoryMenu:DisplaySettings( showQuickslots )
	self.scrollBox:SetVisible( showQuickslots );
end

function InventoryMenu:AddCommandsBar()
end

function InventoryMenu:GetSelection()
	return self.barList:GetSelection();
end

function InventoryMenu:ClearSelection()
	local settings = theSettingsManager:GetSettings();
	settings.selectedBar = 0;
	self.scrollBox:SetVisible( false );
	self.barList:SetSelection();
end

function InventoryMenu:RefreshComboBox( barid )
	self.barList:Clear();
	for key, value in pairs (theSettingsManager:GetBars( WINDOWBAR )) do
		local found = false;
		for i = 1, self.barList:GetItemCount() do
			if ( self.barList:GetItem(i) == key) then
				found = true;
			end
		end
		if ( found == false ) then
			local text = key;
			local barSettings = theSettingsManager:GetBarSettings( key );
			if ( barSettings.barName ~= nil ) then
				text = barSettings.barName;
			end
			self.barList:AddItem( text, key );
		end
	end
	if ( barid ~= nil ) then
		self.barList:SetSelection( barid );
	end
end